/* File:        org.molgenis.omx/model/MolgenisRoleGroupLink.java
 * Copyright:   GBIC 2000-2,013, all rights reserved
 * Date:        August 21, 2013
 * Template:	JpaMapperGen.java.ftl
 * generator:   org.molgenis.generators.db.JpaMapperGen 4.0.0-testing
 *
 * Jpa Entity Mapper, helper to add, delete and update entities
 * 
 * THIS FILE HAS BEEN GENERATED, PLEASE DO NOT EDIT!
 */

package org.molgenis.omx.auth.db;

@edu.umd.cs.findbugs.annotations.SuppressWarnings(value = "DLS_DEAD_LOCAL_STORE", justification = "Too much template code required to prevent warnings")
public class MolgenisRoleGroupLinkJpaMapper extends org.molgenis.framework.db.jpa.AbstractJpaMapper<org.molgenis.omx.auth.MolgenisRoleGroupLink>
{
	private final static org.apache.log4j.Logger log = org.apache.log4j.Logger.getLogger(MolgenisRoleGroupLinkJpaMapper.class);

	public MolgenisRoleGroupLinkJpaMapper(org.molgenis.framework.db.Database db) 
	{
		super(db);
	}
	
	@Override
	public String createFindSqlInclRules(org.molgenis.framework.db.QueryRule[] rules) throws org.molgenis.framework.db.DatabaseException
	{
		return "SELECT MolgenisRoleGroupLink.id"
			+", MolgenisRoleGroupLink.Identifier"
			+", MolgenisRoleGroupLink.Name"
			+", MolgenisRoleGroupLink.group_"
			+", MolgenisRoleGroupLink.role_"
			//parent is SimpleTree(name='group_')
			+", xref_group_.Name AS group__Name"
			//parent is SimpleTree(name='role_')
			+", xref_role_.Name AS role__Name"
			+" FROM MolgenisRoleGroupLink "

			
			//label for group_=Name
//path==group_. type==xref.
//path==group__Name. type==string.
//in if path.value.type != "xref" && !pathlist?seq_contains(path.getParent().name)
		   	+" LEFT JOIN MolgenisRole AS xref_group_ " 
			+" ON xref_group_.id = MolgenisRoleGroupLink.group_"
			
			//label for role_=Name
//path==role_. type==xref.
//path==role__Name. type==string.
//in if path.value.type != "xref" && !pathlist?seq_contains(path.getParent().name)
		   	+" LEFT JOIN MolgenisRole AS xref_role_ " 
			+" ON xref_role_.id = MolgenisRoleGroupLink.role_"
;
	}	

	/** This method first saves the objects that are being refered to by entity, 
	then the entity itself and 
	finally the objects that refer to this object*/
    public void create(org.molgenis.omx.auth.MolgenisRoleGroupLink entity) throws org.molgenis.framework.db.DatabaseException {
        try {


			//check if the object refered by 'group_' is known in the databse
			if(entity.getGroup() != null)
			{
				//if object has been added as xref, but not yet stored (has no id) -> add the refered object
				if(entity.getGroup().getIdValue() == null)
					new org.molgenis.omx.auth.db.MolgenisGroupJpaMapper(getDatabase()).create(entity.getGroup());
				//if object has id (so is stored) but not in this em -> retrieve proper reference reference
				else if (!getEntityManager().contains(entity.getGroup()) && entity.getGroup().getIdValue() != null)
					entity.setGroup(getEntityManager().getReference(org.molgenis.omx.auth.MolgenisGroup.class, entity.getGroup().getIdValue()));
			} else { //object is reference by xref	
				if(entity.getGroup_Id() != null) {
					entity.setGroup((org.molgenis.omx.auth.MolgenisGroup)getEntityManager().find(org.molgenis.omx.auth.MolgenisGroup.class, entity.getGroup_Id()));
				}
			}
			//check if the object refered by 'role_' is known in the databse
			if(entity.getRole() != null)
			{
				//if object has been added as xref, but not yet stored (has no id) -> add the refered object
				if(entity.getRole().getIdValue() == null)
					new org.molgenis.omx.auth.db.MolgenisRoleJpaMapper(getDatabase()).create(entity.getRole());
				//if object has id (so is stored) but not in this em -> retrieve proper reference reference
				else if (!getEntityManager().contains(entity.getRole()) && entity.getRole().getIdValue() != null)
					entity.setRole(getEntityManager().getReference(org.molgenis.omx.auth.MolgenisRole.class, entity.getRole().getIdValue()));
			} else { //object is reference by xref	
				if(entity.getRole_Id() != null) {
					entity.setRole((org.molgenis.omx.auth.MolgenisRole)getEntityManager().find(org.molgenis.omx.auth.MolgenisRole.class, entity.getRole_Id()));
				}
			}

			//prevents uncontrolled recursion call of create (stack overflow)
          
          if(entity.getIdValue() != null) {
            entity = getEntityManager().merge(entity);            
          } else {
            getEntityManager().persist(entity);
          }
//inverse association relation

        } catch (Exception ex) {
            try {
				getEntityManager().getTransaction().rollback();
            } catch (Exception re) {
                throw new org.molgenis.framework.db.DatabaseException("An error occurred attempting to roll back the transaction: "+re.getMessage());
            }
            throw new org.molgenis.framework.db.DatabaseException(ex);
        }
    }

	public void destroy(org.molgenis.omx.auth.MolgenisRoleGroupLink molgenisRoleGroupLink) throws org.molgenis.framework.db.DatabaseException {
		try {
			try {
				molgenisRoleGroupLink = getEntityManager().getReference(org.molgenis.omx.auth.MolgenisRoleGroupLink.class, molgenisRoleGroupLink.getIdValue());
			} catch (javax.persistence.EntityNotFoundException enfe) {
				throw new org.molgenis.framework.db.DatabaseException("The molgenisRoleGroupLink with id " + molgenisRoleGroupLink.getIdField().toString() + " no longer exists: " + enfe.getMessage());
			}

			getEntityManager().remove(molgenisRoleGroupLink);
		} catch (Exception ex) {
			try {
				getEntityManager().getTransaction().rollback();
			} catch (Exception re) {
				throw new org.molgenis.framework.db.DatabaseException("An error occurred attempting to roll back the transaction: "+re.getMessage());
			}
			throw new org.molgenis.framework.db.DatabaseException(ex);
		} 
	}


	public void edit(org.molgenis.omx.auth.MolgenisRoleGroupLink molgenisRoleGroupLink) throws org.molgenis.framework.db.DatabaseException {
		try {





			//1
			org.molgenis.omx.auth.MolgenisGroup group_New = molgenisRoleGroupLink.getGroup();

			if (group_New == null) { //object is reference by xref		
                            if(molgenisRoleGroupLink.getGroup_Id() != null) {
                                molgenisRoleGroupLink.setGroup((org.molgenis.omx.auth.MolgenisGroup)getEntityManager().find(org.molgenis.omx.auth.MolgenisGroup.class, molgenisRoleGroupLink.getGroup_Id()));
                            }
			}


			//5
			org.molgenis.omx.auth.MolgenisRole role_New = molgenisRoleGroupLink.getRole();

			if (role_New == null) { //object is reference by xref		
                            if(molgenisRoleGroupLink.getRole_Id() != null) {
                                molgenisRoleGroupLink.setRole((org.molgenis.omx.auth.MolgenisRole)getEntityManager().find(org.molgenis.omx.auth.MolgenisRole.class, molgenisRoleGroupLink.getRole_Id()));
                            }
			}
			if(!getEntityManager().contains(molgenisRoleGroupLink)) {
				molgenisRoleGroupLink = getEntityManager().merge(molgenisRoleGroupLink);
			}
			


		} catch (Exception ex) {
			try {
				getEntityManager().getTransaction().rollback();
			} catch (Exception re) {
				throw new org.molgenis.framework.db.DatabaseException("An error occurred attempting to roll back the transaction: " + re.getMessage());
			}
			throw new org.molgenis.framework.db.DatabaseException(ex);
		} 
	}

	@Override
	public int executeAdd(java.util.List<? extends org.molgenis.omx.auth.MolgenisRoleGroupLink> entities) throws org.molgenis.framework.db.DatabaseException
	{	
		int count = 0;
		
		try 
		{
			for (org.molgenis.omx.auth.MolgenisRoleGroupLink molgenisRoleGroupLink : entities) 
			{
				create(molgenisRoleGroupLink);
				++count;
			}
		}
		catch (Exception ex) 
		{
            throw new org.molgenis.framework.db.DatabaseException(ex);
        }
		return count;
	}

	@Override
	public int executeUpdate(java.util.List<? extends org.molgenis.omx.auth.MolgenisRoleGroupLink> entities) throws org.molgenis.framework.db.DatabaseException
	{
		int count = 0;

		try
		{
			for (org.molgenis.omx.auth.MolgenisRoleGroupLink molgenisRoleGroupLink : entities) 
			{
				edit(molgenisRoleGroupLink);
				++count;
			} 
			return count;
		}
		catch (Exception ex) 
		{
            throw new org.molgenis.framework.db.DatabaseException(ex);
        }		
	}

	@Override
	public int executeRemove(java.util.List<? extends org.molgenis.omx.auth.MolgenisRoleGroupLink> entities) throws org.molgenis.framework.db.DatabaseException
	{
		int count = 0;		
		try 
		{
			for (org.molgenis.omx.auth.MolgenisRoleGroupLink molgenisRoleGroupLink : entities) 
			{
				destroy(molgenisRoleGroupLink);
				++count;
			}
		} 
		catch (Exception ex) 
		{
            throw new org.molgenis.framework.db.DatabaseException(ex);
        }
		return count;
	}
	
	@Override
	public String getTableFieldName(String fieldName)
	{
		if("id".equalsIgnoreCase(fieldName)) return "id";
		if("MolgenisRoleGroupLink_id".equalsIgnoreCase(fieldName)) return "id";
		if("Identifier".equalsIgnoreCase(fieldName)) return "Identifier";
		if("MolgenisRoleGroupLink_Identifier".equalsIgnoreCase(fieldName)) return "Identifier";
		if("Name".equalsIgnoreCase(fieldName)) return "Name";
		if("MolgenisRoleGroupLink_Name".equalsIgnoreCase(fieldName)) return "Name";
		if("group_".equalsIgnoreCase(fieldName)) return "group_";
		if("MolgenisRoleGroupLink_group_".equalsIgnoreCase(fieldName)) return "group_";
		if("role_".equalsIgnoreCase(fieldName)) return "role_";
		if("MolgenisRoleGroupLink_role_".equalsIgnoreCase(fieldName)) return "role_";
		if("group__id".equalsIgnoreCase(fieldName)) return "group_";
		if("MolgenisRoleGroupLink_group__id".equalsIgnoreCase(fieldName)) return "group_";
		if("group__Name".equalsIgnoreCase(fieldName)) return "group_.Name";	
		if("MolgenisRoleGroupLink_group__Name".equalsIgnoreCase(fieldName)) return "group_.Name";
		if("role__id".equalsIgnoreCase(fieldName)) return "role_";
		if("MolgenisRoleGroupLink_role__id".equalsIgnoreCase(fieldName)) return "role_";
		if("role__Name".equalsIgnoreCase(fieldName)) return "role_.Name";	
		if("MolgenisRoleGroupLink_role__Name".equalsIgnoreCase(fieldName)) return "role_.Name";
		return fieldName;
	}
	
	/**
	 * Return EMPTY list of given allocated size
	 *
	 * @param i initial capacity of returned EMPTY list
	 * @return an EMPTY list with initial capacity given by size
	 */
	@Override
	public java.util.List<org.molgenis.omx.auth.MolgenisRoleGroupLink> createList(int size)
	{
		return new java.util.ArrayList<org.molgenis.omx.auth.MolgenisRoleGroupLink>(size);
	}			

	@Override
	public org.molgenis.omx.auth.MolgenisRoleGroupLink create()
	{
		return new org.molgenis.omx.auth.MolgenisRoleGroupLink();
	}

	@Override
	//Resolve
	public void resolveForeignKeys(java.util.List<org.molgenis.omx.auth.MolgenisRoleGroupLink> entities)  throws org.molgenis.framework.db.DatabaseException, java.text.ParseException
	{
		//create foreign key map for field 'group_' to molgenisGroup.id using Name)	
		//we will use a hash of the values to ensure that entities are only queried once	
		final java.util.Map<String, org.molgenis.framework.db.QueryRule> group_Rules = new java.util.LinkedHashMap<String, org.molgenis.framework.db.QueryRule>();
		//create foreign key map for field 'role_' to molgenisRole.id using Name)	
		//we will use a hash of the values to ensure that entities are only queried once	
		final java.util.Map<String, org.molgenis.framework.db.QueryRule> role_Rules = new java.util.LinkedHashMap<String, org.molgenis.framework.db.QueryRule>();
		//create all query rules	
		for(org.molgenis.omx.auth.MolgenisRoleGroupLink object: entities)
		{
			//create xref/mref rule filtering MolgenisGroup on the label Name
			if(object.getGroup_Id() == null && object.getGroup_Name() != null)
			{
				Object label = object.getGroup_Name();
				{
					org.molgenis.framework.db.QueryRule xrefFilter = new org.molgenis.framework.db.QueryRule("Name", org.molgenis.framework.db.QueryRule.Operator.EQUALS, label.toString());
					
					if(label != null && !group_Rules.containsKey(label))
					{
						group_Rules.put(""+label, xrefFilter);
						group_Rules.put(""+label+"_OR_", new org.molgenis.framework.db.QueryRule(org.molgenis.framework.db.QueryRule.Operator.OR));
					}
				}
			}		
			//create xref/mref rule filtering MolgenisRole on the label Name
			if(object.getRole_Id() == null && object.getRole_Name() != null)
			{
				Object label = object.getRole_Name();
				{
					org.molgenis.framework.db.QueryRule xrefFilter = new org.molgenis.framework.db.QueryRule("Name", org.molgenis.framework.db.QueryRule.Operator.EQUALS, label.toString());
					
					if(label != null && !role_Rules.containsKey(label))
					{
						role_Rules.put(""+label, xrefFilter);
						role_Rules.put(""+label+"_OR_", new org.molgenis.framework.db.QueryRule(org.molgenis.framework.db.QueryRule.Operator.OR));
					}
				}
			}		
		}

		//resolve foreign key field 'group_' to molgenisGroup.id using Name)
		final java.util.Map<String,Integer> group__Labels_to_IdMap = new java.util.TreeMap<String,Integer>();
		if(group_Rules.size() > 0)
		{		
		
			java.util.List<org.molgenis.omx.auth.MolgenisGroup> group_List = null;
			try
			{
				group_List = getDatabase().find(org.molgenis.omx.auth.MolgenisGroup.class, group_Rules.values().toArray(new org.molgenis.framework.db.QueryRule[group_Rules.values().size()]));
			}
			catch(Exception e)
			{
				// something went wrong while querying for this entities' name field
				// we assume it has no such field, which should have been checked earlier ofcourse
				// regardless, just quit the function now
				throw new org.molgenis.framework.db.DatabaseException(e);
			}
		
			for(org.molgenis.omx.auth.MolgenisGroup xref :  group_List)
			{
				String key = "";
				key += 	xref.getName();
				
				group__Labels_to_IdMap.put(key, xref.getId());
			}
		}
		//resolve foreign key field 'role_' to molgenisRole.id using Name)
		final java.util.Map<String,Integer> role__Labels_to_IdMap = new java.util.TreeMap<String,Integer>();
		if(role_Rules.size() > 0)
		{		
		
			java.util.List<org.molgenis.omx.auth.MolgenisRole> role_List = null;
			try
			{
				role_List = getDatabase().find(org.molgenis.omx.auth.MolgenisRole.class, role_Rules.values().toArray(new org.molgenis.framework.db.QueryRule[role_Rules.values().size()]));
			}
			catch(Exception e)
			{
				// something went wrong while querying for this entities' name field
				// we assume it has no such field, which should have been checked earlier ofcourse
				// regardless, just quit the function now
				throw new org.molgenis.framework.db.DatabaseException(e);
			}
		
			for(org.molgenis.omx.auth.MolgenisRole xref :  role_List)
			{
				String key = "";
				key += 	xref.getName();
				
				role__Labels_to_IdMap.put(key, xref.getId());
			}
		}

		//update objects with the keys
		for(int i = 0; i < entities.size(); i++)
		{
			org.molgenis.omx.auth.MolgenisRoleGroupLink object = entities.get(i);		
			//update object using label fields Name
			if(object.getGroup_Id() == null )
			{
					String key = "";
					if(object.getGroup_Name() != null)
						key += 	object.getGroup_Name();
					
					if(!"".equals(key) && group__Labels_to_IdMap.get(key) == null) 
					{
						throw new org.molgenis.framework.db.DatabaseException("group__Name cannot be resolved: unknown xref='"+key+"'");
					}
					else
					{
						object.setGroup_Id(group__Labels_to_IdMap.get(key));
					}
			}
			//update object using label fields Name
			if(object.getRole_Id() == null )
			{
					String key = "";
					if(object.getRole_Name() != null)
						key += 	object.getRole_Name();
					
					if(!"".equals(key) && role__Labels_to_IdMap.get(key) == null) 
					{
						throw new org.molgenis.framework.db.DatabaseException("role__Name cannot be resolved: unknown xref='"+key+"'");
					}
					else
					{
						object.setRole_Id(role__Labels_to_IdMap.get(key));
					}
			}
						
		}
	}	
	
	@Override
	public org.molgenis.fieldtypes.FieldType getFieldType(String fieldName)
	{
			if("id".equalsIgnoreCase(fieldName) || "molgenisRoleGroupLink.id".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.IntField();
			if("identifier".equalsIgnoreCase(fieldName) || "molgenisRoleGroupLink.identifier".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.StringField();
			if("name".equalsIgnoreCase(fieldName) || "molgenisRoleGroupLink.name".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.StringField();
			if("group_".equalsIgnoreCase(fieldName) || "molgenisRoleGroupLink.group_".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.XrefField();
			if("role_".equalsIgnoreCase(fieldName) || "molgenisRoleGroupLink.role_".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.XrefField();
		return null;
	}		
	@Override
	public void prepareFileAttachements(java.util.List<org.molgenis.omx.auth.MolgenisRoleGroupLink> entities, java.io.File baseDir) throws java.io.IOException
	{
	}

	@Override
	public boolean saveFileAttachements(java.util.List<org.molgenis.omx.auth.MolgenisRoleGroupLink> entities, java.io.File baseDir) throws java.io.IOException
	{
		return false;
	}}
